<?php

# VERSION=4
# CHANGES="use full path to mkdir to create /tmp/images"

include('/usr/fallback/beroConf.php');
include('/usr/php/include/updateTool.php');
include('/usr/www/include/berogui_small.class.php');

$bc = new beroConf('root');
require_once('/usr/www/include/redirect_fwupdate.php');

function display_install ($pkgname) {

	$ret =	'<h3>Install Update-Package</h3>' . "\n" .
		'<table>' . "\n" .
		'<tr>' . "\n" .
		'<th colspan="2">' . $pkgname . '</th>' . "\n" .
		'</tr>' . "\n" .
		'<tr>' . "\n" .
		'<td>' . "\n" .
		'<form name="delete_form" action="/cgi-bin/update-tool.php" method="POST">' . "\n" .
		'<input type="hidden" name="action" value="delete" / >' . "\n" .
		'<input type="hidden" name="file" value="' . $pkgname . '" / >' . "\n" .
		'<input type="submit" value="Delete" onclick="return confirm_delete(\'' . $pkgname . '\');" />' . "\n" .
		'</form>' . "\n" .
		'</td>' . "\n" .
		'<td>' . "\n" .
		'<form name="install_form" action="/cgi-bin/update-tool.php" method="POST">' . "\n" .
		'<input type="hidden" name="action" value="install" / >' . "\n" .
		'<input type="hidden" name="file" value="' . $pkgname . '" / >' . "\n" .
		'<input type="submit" value="Install" onclick="return confirm_install(\'' . $pkgname . '\');" />' . "\n" .
		'</form>' . "\n" .
		'</td>' . "\n" .
		'</tr>' . "\n" .
		'</table>' . "\n";

	return($ret);
}

function display_upload ($upd) {

	exec('/bin/grep nameserver /etc/resolv.conf', $output, $retval);
	$dns_on = (($retval == 0) ? 1 : 0);
	unset($output);
	unset($retval);

	exec('/bin/ping -c 1 beronet.com', $output, $retval);
	$dns_works = (($retval == 0) ? 1 : 0);
	unset($output);
	unset($retval);

	if ($dns_on && $dns_works) {
		$file_list = $upd->getdownloadlist();

		if (($file_list != false) && (count($file_list) > 0)) {
			$ret =	'<h3>Download Update-Package from beroNet</h3>' . "\n" .
				'<table style="font-size: 13px;">' . "\n" .
				'<tr><th>Name</th><th>Type</th><th>Release Notes</th><th>Action</th></tr>' . "\n";
			foreach ($file_list as $entry) {
				$ret .=	'<tr>' . "\n" .
					'<td>' . $entry['name'] . '</td>' . "\n" .
					'<td>' . $entry['type'] . '</td>' . "\n" .
					'<td>' . ((strlen($entry['notesurl']) != 0) ? '<a href="' . $entry['notesurl'] . '" target="_blank">open</a>' : 'none') . '</td>' . "\n" .
					'<td>' . "\n" .
					'<form action="/cgi-bin/update-tool.php" method="POST">' . "\n" .
					'<input type="hidden" name="action" value="download" />' . "\n" .
					'<input type="hidden" name="package_url" value="' . $entry['url'] . '" />' . "\n" .
					'<input type="submit" value="Download" />' . "\n" .
					'</form>' . "\n" .
					'</td>' . "\n" .
					'</tr>' . "\n";
			}
			$ret .=	'</table><br />' . "\n";
		}

		$ret .=	'<h3>Download Update-Package from Web</h3>' . "\n" .
			'<span style="font-size: 11px;">Downloading an Update-Package from a Webserver can take a few minutes.<br />' . "\n" .
			'Please do not abort the download-process!</span><br /><br />' . "\n" .
			'<form action="/cgi-bin/update-tool.php" method="POST">' . "\n" .
			'<input type="hidden" name="action" value="download" />' . "\n" .
			'<input type="input" name="package_url" style="font-size: 10px; font-family: monospace; width: 400px; margin-bottom: 5px;" /><br />' . "\n" .
			'<input type="submit" value="Download" />' . "\n" .
			'</form><br />';
	}

	$ret .= '<h3>Upload Update-Package from your Computer</h3>' . "\n" .
		'<form enctype="multipart/form-data" action="/cgi-bin/update-tool.php" method="POST">' . "\n" .
		'<input type="hidden" name="action" value="upload" />' . "\n" .
		'<input type="hidden" name="MAX_FILE_SIZE" value="52428800" />' . "\n" .
		'<input type="file" name="userfile" />' . "\n" .
		'<input type="submit" value="Upload" />' . "\n" .
		'</form>';

	return($ret);
}

$gui = new berogui_small('beroNet VoIP Gateway: Firmware-Update');
$upd = new updateTool();

echo	$gui->header(($_POST['action'] == 'install') ? 0 : 1) .
	'<div style="text-align: center;">' . "\n";

switch ($_POST['action']) {
default:
case 'upload':
	if (!isset($_FILES['userfile']['name'])) {
		echo display_upload($upd);
		break;
	}

	$ret = $upd->upload($_FILES);
	if ($ret['message'] != false) {
		echo	'<h3>Messages</h3>' . "\n" .
			(($ret['error'] == true) ? 'Error:' : 'Warning:') . ' ' . $ret['message'] . "\n";
	}

	echo (($ret['filename'] != false) ? display_install($ret['filename']) : display_upload($upd));
	break;
case 'download':
	$ret = $upd->download($_POST['package_url']);
	if ($ret['message'] != false) {
		echo	'<h3>Messages</h3>' . "\n" .
			(($ret['error'] == true) ? 'Error:' : 'Warning:') . ' ' . $ret['message'] . "\n";
	}
	echo (($ret['filename'] != false) ? display_install($ret['filename']) : display_upload($upd));
	break;
case 'delete':
	echo	'<h3>Messages</h3>' .
		'Deleting Update-Package \'' . $_POST['file'] . '\' was ' . ($upd->pkgdelete($_POST['file']) ? '' : 'un') . 'successful.' .
		display_upload($upd);
	break;
case 'install':
	echo 	'<h3>Installation-Progress</h3>' . "\n" .
		'<div style="text-align: left;">' . "\n" .
		'<pre>' . "\n";

	$retval = $upd->install($_POST['file']);
	if ($retval != 0) {
		echo 	'</pre>' . "\n" .
			'Error: Could not install Update-Package \'' . $_POST['file'] . '\'! (returned ' . $retval . ')' . "\n" .
			'</div>' . "\n";
		break;
	}


	echo 	'</pre><br /><br />' . "\n" .
		'<script type="text/javascript">window.setTimeout(\'setRequest()\', ' . (file_exists('/tmp/reboot_after_update') ? '7000' : '1000') . ');</script>' . "\n" .
		'Please wait until you will be redirected to the login-page or click <a href="/">here</a> to login.<br />' . "\n" .
		'</div>' . "\n";
	break;
}

echo	'</div>' . "\n" .
	$gui->footer('update-tool');

if (file_exists('/tmp/reboot_after_update')) {
            exec('/sbin/reboot');
}

?>
